<?php

namespace App\Model\History;

class SubscribeList extends Base
{
    protected $updateTime = false;
    protected $autoTimeStamp = true;
    protected $pk = 'id';
    protected $createTime = 'create_time';
    protected $tableName = 'subscribe_list';
    protected $tableField = [
        'title' => ['type' => 'like'],
    ];

    protected $operation = [
        'add' => [
            'field' => '*',
        ],
        'edit' => [
            'field' => '*'
        ],
        'search' => [
            'field' => ['title'],
        ]
    ];

    protected $validate = [
        'title' => 'require',
    ];

    protected $validateMessage = [
        'title.require' => '标题不可以为空',
    ];

    public static function getAll()
    {
        $data = static::create()->all();
        return array_map(function ($v) {
            return $v->toArray();
        }, $data);
    }

    public function getReadAbleData($id)
    {
        $data = $this->where(['id' => $id])->get();
        if (!$data) {
            $data = [];
        } else {
            $data = $data->toArray();
        }
        $usage = ServerList::getServerUsage($id);
        return array_merge($data, ['_all_' => $usage['total'], 'in_use' => $usage['use'], '_unique_' => $usage['ip'], '_forbidden_' => $usage['forbidden'], '_never_' => $usage['never']]);
    }
}
