<?php

namespace App\WebSocket;

use App\Tools\System;
use EasySwoole\Component\Singleton;
use Swoole\Coroutine;
use Swoole\Coroutine\Http\Client;

class WebSocketClient
{
    use Singleton;

    private $client;
    private $isConnect = false;

    public function __construct()
    {
        System::log('__construct');
        $this->connect();
    }

    private function connect()
    {
        if ($this->isConnect) {
            return;
        }
        $this->isConnect=true;
//        $this->client = new Client("8.210.151.167", 9502);
        $this->client = new Client("127.0.0.1", '9509');
        $ret = $this->client->upgrade("/server");
        if (!$ret) {
            System::log($this->client->errMsg,'websocket connect error');
            $this->close();
        } else {
            System::log('websocket connect success');
        }
        $this->isConnect = false;
    }

    public function close(){
        if ($this->client) $this->client->close();
        $this->client = null;
        $this->isConnect = false;
    }
    public function push($data = '')
    {
        if ($this->client) {
            $status=$this->client->push($data);
            if (!$status){
                $this->close();
                $this->connect();
            }
        } else {
            $this->close();
            $this->connect();
        }
    }
}